/***********************************************************************
 * This is an incomplete graphic library all in assembly!
 * I don't have time to complete it :(
 *
 * These routine are much faster also lighter than my old C routines (even
 * the partial asm ellipse!)
 *
 * The working routines are:
 *
 * - WH_pix_addr: returns the memory address of (x,y) - also 3rd argument
 *		  will hold the bit number in the byte (count from LSB.)
 * - WH_set_pix	: this a direct write to the LCD memory.
 *		  I think this is much faster than using the REX.
 * - WH_circle	: it's a direct ASM translation of my previous circle
 *		  C function used in REXDK library.
 * - WH_Ellipse	: This is not full ASM but modefied C to save some bytes
 *		  by elemenating Set4Pixels & re-using part of the circle
 *		  code. It's faster & smaller!
 * - WH_clrscr	: It's smaller than calling DsClearScreen (it's actually
 *		  a call to DisplayBlockClear) and I think it's faster!
 *		  DsClearScreen costs 0 byte per AddIn but costs 27 bytes 
 *		  for every DsClearScreen call!
 *		  WH_clrscr costs 13 bytes per program & 3 bytes per call!
 *		  So a single call to WH_clrscr saves 11 bytes and each 
 *		  additional call saves 24 bytes! :)
 * - WH_fillscr	: Same as above but has a fill pattern parameter.
 *		  This routine costs 18 bytes per program & only
 *		  8 bytes per call!
 *		  so even a single call to WH_clrscr saves 1 byte over
 *		  DisplayBlockClear :)
 *
 * Wanted to write the following routines :(
 * - Have the routines handle XOR pixels & 
 * - A full ASM ellipse.
 * - Box.
 * - Multi-point polygon.
 * - Beziers curves.
 * - Curve-fit to point array.
 * - Fill area (given a seed point.)
 * - Filled circle, ellipse, Box & polygon
 * - Sprite routines:
 *	. Store display block
 *	. Restore display block.
 *	. Super-impose sprite block
 *	  (sprite block pixel types are: White, Black & transparent)
 *
 *
 * Module  : Graphics routines - ASM version (incomplete!)
 * Version : 2.0
 * Author  : Waleed Hasan
 * Date    : January 15th, 2002
 *	     (Released February 19th, 2002)
 *
 * I got 2 nice feedbacks after releasing version 2.0 so I added these
 * functions.
 * - WH_get_pix	: get pixel value, returns 0/1 (read the comment in the
 *		  function code)
 * - WH_reset_pix : resets the pixel.
 * - WH_inv_pix	: inverts the pixel.
 * 
 * Version : 2.1
 *	     Released February 22nd, 2002
 **********************************************************************/

#include <rex/rex.h>

#include "WHgraph21.h"

/************************************************************************
 Clear screen
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_clrscr(void)
{
#asm
	ld	hl,$a000
	ld	bc,30*120
.clrLoop
	ld	(hl),0
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,clrLoop
#endasm
}

/************************************************************************
 Screen pattern fill
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_fillscr(int pattern)
{
#asm
;
; LCD memory pattern fill
; C - entry point
	pop	bc
	pop	hl
	ld	d,l
	push	bc
	push	bc
;
; LCD memory pattern fill
; ASM - entry point
;
; i/p	: d = fill pattern
; uses	: AF,BC,HL,DE
.fill_scr
	ld	hl,$a000

	ld	e,1		; pattern mask
	ld	b,120		; number of lines
.scrFillLoop
	push	bc
	ld	b,30
.scrFillLine
	ld	a,d
	and	e
	jr	z,skipFill
	ld	(hl),d
.skipFill
	inc	hl
	djnz	scrFillLine
	pop	bc
	rlc	e
	djnz	scrFillLoop
	
#endasm
}


/************************************************************************
  pixel memory address
			By Waleed Hasan - 11Jan2002

 bit is a pointer to an unsigned char that will receive the bit number
 and the function will return the memory address
************************************************************************/
unsigned int WH_pix_addr(int x,int y, unsigned char *bit)
{
#asm
; LCD memory pixel addres
; C - entry point
	pop	de		;ret addr.
	pop	bc		;&bit	
	pop	hl		;y
	ld	a,l		; a=y
	pop	hl		;x
				; l=x
	push	de
	push	de
	push	de
	push	de
	
	ld	d,l		; d=x
	ld	e,a		; e=y
	
	ld	a,l
	and	$07

;
; LCD memory pixel addres
; ASM - entry point
;
; i/p	: D=x		E=y
; uses	: AF,BC,HL,DE
; o/p	: HL=LCD memory byte address	C=pixel bit
.pixel_addr
	ld	c,$80


	ld	a,d
	and	$07
	ld	b,a
	jr	z,SkpShft
.ShftOne
	srl	c		
	djnz	ShftOne
.SkpShft				; c = pixel bit.

	ld	a,d
	srl	a
	srl	a
	srl	a			; a = pixel byte
	
	ld	h,b
	ld	l,e			; HL = Y
	ld	d,h			; DE = Y
;
;we need to multiply Y by 30
;
	add	hl,hl			; HL = 2*Y

	add	hl,hl			; HL = 4*Y
	add	hl,hl			; HL = 8*Y
	add	hl,hl			; HL = 16*Y
	sbc	hl,de			; HL = 15*Y
	add	hl,hl			; HL = 30*Y

	ld	de,$a000
	add	hl,de
	
	ld	e,a
	ld	d,b
	add	hl,de
; hl = memory address
;  c = pixel bit
#endasm
}


/************************************************************************
  Direct pixel read
			By Waleed Hasan - 11Jan2002
************************************************************************/
int WH_get_pix(int x,int y)
{
#asm
; direct LCD pixel plot
; C - entry point
	pop	bc		;ret addr.
	pop	hl		;y
	ld	e,l		; e=y
	pop	hl		;x
	ld	d,l		; d=x

	push	bc
	push	bc
	push	bc	
;
; direct LCD pixel read
; ASM entry point
;
; i/p	: D=x		E=y
; uses	: AF,BC,HL,DE
;
.get_pix_asm
	call	pixel_addr
	ld	a,(hl)
	ld	h,b		; B=0 from DJNZ in pixel_addr :)

;this returns '0' not set & '1' for set!
	ld	l,b
	and	c
	ret	z
	inc	l

; we can save 2 bytes (!) by simply returning '0' not set & 'non-zero' for set!
; the non-zero will be the pixel-bit no.
;	and	c
;	ld	l,a

#endasm
}


/************************************************************************
  (partial) ASM ellipse drawing routine
			By Waleed Hasan - 11Jan2002

  This is not in full assembly, but calling the asm set_4_pix
  saved some bytes & made the ellipse drawing faster
 ************************************************************************/
void WH_Ellipse(int xc,int yc,int a0,int b0)
{
 	long a=a0,b=b0;
 	int x=0,y=b0;
	long asq=a*a,tasq=asq<<1;
 	long bsq=b*b,tbsq=bsq<<1;

 	long d=bsq-asq*b+asq>>2,dx=0,dy=tasq*b;

 	while(dx<dy)
	{
#asm
	call	ellipse_set_4_pix
#endasm
		if(d>0L) {y--;dy-=tasq;d-=dy;}
		x++;dx+=tbsq;d+=bsq+dx;
	}
 	d+=(3L*(asq-bsq)>>1-(dx+dy))>>1;

 	while(y>=0)
	{
#asm
	call	ellipse_set_4_pix
#endasm
	 	if(d<0L) {x++;dx+=tbsq;d+=dx;}
		y--;dy-=tasq;d+=asq-dy;
	}
}


/************************************************************************
	  ASM circle routine
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_Circle(int x, int y, int r)
{
#asm
; ASM Circle draw
; C - entry point
;;
;; some defines to make life easier!
;;
;center X,Y
#define __XC__	b
#define __YC__	c
;running X,Y
#define __X__	h
#define __Y__	l
;plot call X,Y
#define __pX__	d
#define __pY__	e
;a
#define __Az__	de
#define __A__	d


	pop	bc		;ret addr
	pop	hl		;r
	ld	__A__,l		; b=r
	pop	hl		;yc
	ld	e,l		; e=yc
	pop	hl		;xc
	push	bc
	push	bc
	push	bc
	push	bc


	ld	__XC__,l
	ld	__YC__,e

; ASM Circle draw
; ASM - entry point
; i/p : B=xc, C=yc, D=r, H=0
; uses	: AF,BC,HL,DE
.WH_circle_asm
				; x=0;	h=0 alrady!
	ld	__Y__,__A__	; y=r;
	srl	__A__		; a=r>>1
.loop
	push	__Az__

	call	set_4_pix

	ld	a,__XC__
	add	a,__Y__
	ld	__pX__,a
	ld	a,__YC__
	add	a,__X__
	ld	__pY__,a
	call	set_pix_save		;PIX(xc+y,yc+x)

	ld	a,__XC__
	sub	__Y__
	ld	__pX__,a
	call	set_pix_save		;PIX(xc-y,yc+x)

	ld	a,__YC__
	sub	__X__
	ld	__pY__,a
	call	set_pix_save		;PIX(xc-y,yc-x)

	ld	a,__XC__
	add	a,__Y__
	ld	__pX__,a
	call	set_pix_save		;PIX(xc+y,yc-x)

	inc	__X__		;x++;

	pop	__Az__
	ld	a,__A__
	sub	__X__
	ld	__A__,a		;a-=x;

	bit	7,__A__
	jr	z, NextLoop	;if(a>=0)
				;{
	add	a,__Y__
	ld	__A__,a		;a+=y
	dec	__Y__		;y--;
				;}
.NextLoop			;this test should go up!
        ld      a,__X__		;for(;x<=y;)
        sub     __Y__
	jr	c,loop
	jr	z,loop

	ret

.ellipse_set_4_pix
	ld	hl,32
	add	hl,sp

	ld	d,(hl)				;x

	dec	hl
	dec	hl
	ld	e,(hl)				;y

	ld	hl,50
	add	hl,sp

	ld	__XC__,(hl)			;B=xc
	dec	hl
	dec	hl
	ld	__YC__,(hl)			;C=yc

	ex	de,hl				;H=x
						;L=y
.set_4_pix
	ld	a,__XC__
	add	a,__X__
	ld	__pX__,a
	ld	a,__YC__
	add	a,__Y__
	ld	__pY__,a
	call	set_pix_save		;PIX(xc+x,yc+y)

	ld	a,__XC__
	sub	__X__
	ld	__pX__,a
	call	set_pix_save		;PIX(xc-x,yc+y)

	ld	a,__YC__
	sub	__Y__
	ld	__pY__,a
	call	set_pix_save		;PIX(xc-x,yc-y)

	ld	a,__XC__
	add	a,__X__
	ld	__pX__,a
;	call	set_pix_save		;PIX(xc+x,yc-y)


.set_pix_save

	push	hl
	push	de
	push	bc
	
	call	set_pix_asm

	pop	bc
	pop	de
	pop	hl

#endasm
}


/************************************************************************
  Direct pixel plotting
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_set_pix(int x,int y)
{
#asm
; direct LCD pixel plot
; C - entry point
	pop	bc		;ret addr.
	pop	hl		;y
	ld	e,l		; e=y
	pop	hl		;x
	ld	d,l		; d=x
	
	push	bc
	push	bc
	push	bc	
;
; direct LCD pixel plot
; ASM entry point
;
; i/p	: D=x		E=y
; uses	: AF,BC,HL,DE
;
.set_pix_asm
	call	pixel_addr
.set_pix_asm_2
	ld	a,c
	or	(hl)
	ld	(hl),a
#endasm
}	

/************************************************************************
  Direct pixel inverse!
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_inv_pix(int x,int y)
{
#asm
; direct LCD pixel plot
; C - entry point
	pop	bc		;ret addr.
	pop	hl		;y
	ld	e,l		; e=y
	pop	hl		;x
	ld	d,l		; d=x
	
	push	bc
	push	bc
	push	bc	
;
; direct LCD pixel un-plot
; ASM entry point
;
; i/p	: D=x		E=y
; uses	: AF,BC,HL,DE
;
.inv_pix_asm
	call	pixel_addr
	ld	a,c
	and	(hl)
	jr	z, set_pix_asm_2
	jr	reset_pix_asm_2
#endasm
}


/************************************************************************
  Direct pixel un-plotting!
			By Waleed Hasan - 11Jan2002
************************************************************************/
void WH_reset_pix(int x,int y)
{
#asm
; direct LCD pixel plot
; C - entry point
	pop	bc		;ret addr.
	pop	hl		;y
	ld	e,l		; e=y
	pop	hl		;x
	ld	d,l		; d=x
	
	push	bc
	push	bc
	push	bc	
;
; direct LCD pixel un-plot
; ASM entry point
;
; i/p	: D=x		E=y
; uses	: AF,BC,HL,DE
;
.reset_pix_asm
	call	pixel_addr
.reset_pix_asm_2
	ld	a,c
	CPL
	and	(hl)
	ld	(hl),a
#endasm
}

