/***********************************************************************
 * This is an incomplete graphic library all in assembly!
 * I don't have time to complete it :(
 *
 * These routine are much faster also lighter than my old C routines (even
 * the partial asm ellipse!)
 *
 * The working routines are:
 *
 * - WH_pix_addr: returns the memory address of (x,y) - also 3rd argument
 *		  will hold the bit number in the byte (count from LSB.)
 * - WH_set_pix	: this a direct write to the LCD memory.
 *		  I think this is much faster than using the REX.
 * - WH_circle	: it's a direct ASM translation of my previous circle
 *		  C function used in REXDK library.
 * - WH_Ellipse	: This is not full ASM but modefied C to save some bytes
 *		  by elemenating Set4Pixels & re-using part of the circle
 *		  code. It's faster & smaller!
 * - WH_clrscr	: It's smaller than calling DsClearScreen (it's actually
 *		  a call to DisplayBlockClear) and I think it's faster!
 *		  DsClearScreen costs 0 byte per AddIn but costs 27 bytes 
 *		  for every DsClearScreen call!
 *		  WH_clrscr costs 13 bytes per program & 3 bytes per call!
 *		  So a single call to WH_clrscr saves 11 bytes and each 
 *		  additional call saves 24 bytes! :)
 * - WH_fillscr	: Same as above but has a fill pattern parameter.
 *		  This routine costs 18 bytes per program & only
 *		  8 bytes per call!
 *		  so even a single call to WH_clrscr saves 1 byte over
 *		  DisplayBlockClear :)
 *
 * Wanted to write the following routines :(
 * - Have the routines handle XOR pixels & 
 * - A full ASM ellipse.
 * - Box.
 * - Multi-point polygon.
 * - Beziers curves.
 * - Curve-fit to point array.
 * - Fill area (given a seed point.)
 * - Filled circle, ellipse, Box & polygon
 * - Sprite routines:
 *	. Store display block
 *	. Restore display block.
 *	. Super-impose sprite block
 *	  (sprite block pixel types are: White, Black & transparent)
 *
 *
 * Module  : Graphics routines - ASM version (incomplete!)
 * Version : 2.0
 * Author  : Waleed Hasan
 * Date    : January 15, 2002
 *	     (Released February 19, 2002)
 *
 * I got 2 nice feedbacks after releasing version 2.0 so I added these
 * functions.
 * - WH_get_pix	: get pixel value, returns 0/1 (read the comment in the
 *		  function code)
 * - WH_reset_pix : resets the pixel.
 * - WH_inv_pix	: inverts the pixel.
 * 
 * Version : 2.1
 *	     Released February 22nd, 2002
 **********************************************************************/

#include <rex/rex.h>

/* Version : 2.0 */
void WH_clrscr(void);
void WH_fillscr(int pattern);

void WH_plt_pix(int ,int );
unsigned int WH_pix_addr(int ,int ,unsigned char *);
void WH_Circle(int ,int , int );
void WH_Ellipse(int ,int ,int ,int );

/* Version : 2.1 */
int WH_get_pix(int ,int );
void WH_reset_pix(int ,int );
void WH_inv_pix(int ,int );

