/***********************************************************************
 * This is to test the new ASM graphic library 
 **********************************************************************/

#include <rex/rex.h>

#include "WHgraph21.h"

void itoh(char *str, int n);
void btoh(char *str, unsigned char n);
void WaitExit(char *, int);

#include "WHgraph21.c"

main()
{
 char b;
 int i,j;
 char str[20];

intro1:
 WH_clrscr();

 DsPrintf(0,40,32,"The new thing is, .. it's in assembly!");
 DsPrintf(0,60,16,"That means - IT's FAST, REALLY FAST : )"); 
 WaitExit("This is to demo our new graphics routines!",0);

intro2:
 WH_clrscr();
 DsPrintf(0,40,32,"First with the old  s  l  o  w   routines");
 DsPrintf(0,60,16,"Then using our new FULL-SPEED!"); 
 if(WaitExit("We'll do everything twice!",1)) goto intro1;

pixaddr:
 WH_clrscr();
 i=WH_pix_addr(20,12,&b);
 itoh(str,i);
 DsPrintf(0,40,32,str);
 itoh(str,b);
 DsPrintf(40,40,32,str);
 if(WaitExit("Testing pix_addr for (20,12)",1)) goto intro2;

clr:
 WH_clrscr();
 if(WaitExit("just cleared the screen  : )",1)) goto pixaddr;

clrfl: 
 WH_clrscr();
 WH_fillscr(85);
 if(WaitExit("just clear-filled the screen with 85 : )",1)) goto clr;

old_plt:
 WH_clrscr();
 for(j=15;j<15+90;j+=2)for(i=15+95;i<15+90+95;i+=2)DsDisplayPointSet(i,j,1);
 if(WaitExit("The   sssloooooow  DisplayPointSet : (",1)) goto clrfl;

asm_plt:
 for(j=15;j<15+90;j+=2)for(i=15;i<15+90;i+=2)WH_set_pix(i,j);
 if(WaitExit("Testing WH_set_pix, see how fast it is : )",1)) goto old_plt;

old_crc:
 WH_clrscr();
 for(j=5;j<60;j+=5) DsCircle(110-j,60,j);
 if(WaitExit("My old   sssloooooow   DsCircle  : (",1)) goto asm_plt;

asm_crc:
 for(j=5;j<60;j+=5) WH_Circle(j,60,j);
 if(WaitExit("Testing circles, see how fast it is : )",1)) goto old_crc;

old_elp:
 WH_clrscr();
 for(j=5;j<85;j+=5) DsEllipse(160-j,60,j,j/3*2);
 if(WaitExit("My old   sssloooooow   DsEllipse : (",1)) goto asm_crc;

asm_elp:
 for(j=5;j<85;j+=5) WH_Ellipse(j,60,j,j/3*2);
 if(WaitExit("Testing ellipses, even partially ASM, it's fast! : )",1)) goto old_elp;


old_get:
  WH_clrscr();
 DsDisplayLine(0,20,240,0,0x66);
 for(i=30;i<60;i++)
	for(j=0;j<240;j++)
		if(DsDisplayPointGet(j,20)) DsDisplayPointSet(j,i,1);
 if(WaitExit("Read & write 240 pixel x 30 times in sssloooooow motion",1)) goto asm_elp;

asm_get:
 for(i=70;i<100;i++)
	for(j=0;j<240;j++)
		if(WH_get_pix(j,20))WH_set_pix(j,i);
 if(WaitExit("Read & write 240 pixel x 30 times in SPEED!",1)) goto old_get;

asm_reset:
 for(i=30;i<60;i++)
	for(j=0;j<240;j++)
		WH_reset_pix(j,i);
 if(WaitExit("This is reseting 240 pixel x 30 times in SPEED!",1)) goto asm_get;

asm_inv:
 for(i=70;i<100;i++)
	for(j=0;j<240;j++)
		WH_inv_pix(j,i);
 if(WaitExit("This is inverting 240 pixel x 30 times in SPEED!",1)) goto asm_reset;
}

char *HexChar = 	"0123456789ABCDEF";	// Hex-ASCII lookup table
void itoh(char *str, int n)
{
 str[0] = HexChar[(n>>12) & 0x0f];
 str[1] = HexChar[(n>>8 ) & 0x0f];
 str[2] = HexChar[(n>>4 ) & 0x0f];
 str[3] = HexChar[(n    ) & 0x0f];
 str[4] = 0;
}
void btoh(char *str, unsigned char n)
{
 str[0] = HexChar[(n>>4) & 0x0f];
 str[1] = HexChar[(n   ) & 0x0f];
 str[2] = 0;
}

void WaitExit(char *str, int p)
{
 MSG REXmsg;

 DsEventClear();
 DsDisplayBlockClear(0,0,240,10);
 DsPrintf(0,0,32,str);
 DsDisplayBlockClear(0,111,240,10);
 DsPrintf(22,111,32,"ASM graphics routines - By Waleed Hasan");
 
 DsDialogTextButton(225, 0, 15, 15, 60, "X");
 DsDialogTextButton(225, 105, 15, 15, 61, ">");
 if(p) DsDialogTextButton(0, 105, 15, 15, 62, "<");
 for(;;)
 	{
         DsReadMessage(REXmsg,1);
         if(REXmsg.message == MSG_DS_COMMAND)
		{
		 if(REXmsg.bCode==60) {	DsClearScreen();DsAddinTerminate();}
		 if(REXmsg.bCode==61) return 0;
		 if(REXmsg.bCode==62) return 1;
		}
	}
}
